/*
 * Main.java
 *
 * Created on 13 de abril de 2006, 13:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen;

import objectgen.activitymodel.*;
import objectgen.activitymodel.xmi.XMIFileSaver;
import objectgen.testobjective.*;
import objectgen.testobjective.savers.*;
import objectgen.usecase.*;

import java.io.*;
import java.util.Iterator;

import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.BasicConfigurator;

/**
 * Test class
 * @author Rincew
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main () {
    }
    

    
    //-------------------------------------------
    static void testUseCase01() 
        throws Exception
    {
        Iterator it, it2;
        Activity a;
        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/CU-Link 02.xml");
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        //System.out.println(uc);
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        System.out.println(ad);

        System.out.println ("--- Activities ---");
        it = ad.iteratorActivities ();
        while (it.hasNext ()) { 
            a = (Activity) it.next ();
            System.out.println(a);
            it2 = ad.iteratorTranstitionsBeginInActivity (a);
            while (it2.hasNext ())
                System.out.println("  (t) " + it2.next ());
        }

        System.out.println ("--- Transitions ---");
        it = ad.iteratorTransitions ();
        while (it.hasNext ()) { 
            System.out.println(it.next ());
        }
        
        /*
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        TestObjectiveList tol = tog.generate (ad);
        
        System.out.println("Objectives:");
        System.out.println(tol);
        */
        System.out.println ("Ok.");
        
    }

    //-------------------------------------------
    static void testUseCase02() 
        throws Exception
    {
        Iterator it;
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/CU-Link 02.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/LoginUC.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/SearchLinkByDescription.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/Test01.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/Objectives.xml");
        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/UC01.LoginUC.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/UC03.xml");
        File tof = new File("TestObjectives.tol");
        
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        System.out.println(uc);
        //return;
        
        /**/
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        System.out.println(ad);
        /*
        JoinAlternativeFilter filter = new JoinAlternativeFilter();
        filter.filter (ad);
        */
        System.out.println("\n\nGenerating XMI file:");
        f = new File("temporal.xmi");
        XMIFileSaver fs = new XMIFileSaver();
        fs.save (f, ad);
        /**/
        
        System.out.println("\n\nGenerating Test Objectives:");            
        TestObjectiveGenerator tog = new TestObjectiveGenerator();
        TestObjectiveList tol = tog.generate (ad);
        
        
        ITestObjectivesSaver tos = new BinarySaver();
        tos.save (tof, tol);
        
        ITestObjectivesSaver tox = new XMISaver();
        tox.save (tof, tol);
        
        FileInputStream fis = new FileInputStream(tof);
        ObjectInputStream ois = new ObjectInputStream(fis);
        TestObjectiveList tol2 = (TestObjectiveList)ois.readObject ();

        System.out.println("--------------------------------------\n" +
            "Objectives:");
        System.out.println(tol2);

        /**/
        /**/

        
        System.out.println ("Ok.");
/**/        
    }

    
    //-------------------------------------------
    static void testUseCase03() 
        throws Exception
    {
        Iterator it;
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/CU-Link 02.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/LoginUC.xml");
        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/AddNewLink.xml");
        //File f = new File("C:/Code/TestApps/ObjectGen/sample_files/Test01.xml");
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        //System.out.println(uc);
        //return;
        
        /**/
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        System.out.println("Before: \n"+ad);
        
        
        System.out.println("Joining alternatives:");
        JoinAlternativeFilter filter = new JoinAlternativeFilter();
        filter.filter (ad);
        System.out.println (filter);
        
        System.out.println("After: \n"+ad);

        System.out.println("Generating XMI file:");
        f = new File("C:/Code/TestApps/ObjectGen/sample_files/prueba.xmi.xmi");
        XMIFileSaver fs = new XMIFileSaver();
        fs.save (f, ad);

        
        System.out.println ("Ok.");
/**/        
    }


    
    //----- Test 04 ------------------------
    static void testUseCase04() 
        throws Exception
    {

        File f = new File("C:/Code/TestApps/ObjectGen/sample_files/Test02.xml");
        //File fos = new File("C:/Code/TestApps/ObjectGen/sample_files/ActivityDiagram.bin");
        UseCaseXML uc = new UseCaseXML();
        uc.load (f);
        
        //System.out.println(uc);
       
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);

        FileOutputStream fos = new FileOutputStream("C:/Code/TestApps/ObjectGen/sample_files/ActivityDiagram.bin");
        ObjectOutputStream oos = new ObjectOutputStream(fos);

	oos.writeObject(ad);

	oos.close();
        
        System.out.println ("Activity diagram saved.");
        
        ActivityDiagram newa;
        FileInputStream fis = new FileInputStream("C:/Code/TestApps/ObjectGen/sample_files/ActivityDiagram.bin");
        ObjectInputStream ois = new ObjectInputStream(fis);
        newa = (ActivityDiagram)ois.readObject ();
        System.out.println("New activity diagram: \n" + newa);
        
        
    }
    /**
     * @param args the command line arguments
     */
    public static void main (String[] args) 
        throws Exception
    {
        
        //--- Configure logs -----------
        BasicConfigurator.configure ();
        PropertyConfigurator.configure(/*path+*/"./config/logs.prop");
        objectgen.configuration.Configuration.Create ();
        
        Main m = new Main();
        
        System.out.println(System.getProperty("user.dir"));
        System.out.println("----------------");
        //testUseCase01();
        testUseCase02();
        //testUseCase03();
        //--- Prueba de guardado binario -----------
        //testUseCase04();
    }
    
}
