package objectgen.activitymodel;

import java.io.*;
import java.util.Iterator;
import java.util.ArrayList;

import org.apache.log4j.*;


public class XMIFileSaver {

  
  
  private FileWriter file;
  /*private INode previousNode;
  private INode actualNode;*/
  private int transitionId;
  private int lastTransition;
  private boolean first;
  private ArrayList transitions;
  
  
  //-------------------------------------------------------
  public XMIFileSaver() { 
    /*this.previousNode = null;
    this.actualNode = null;*/
    this.transitionId = 1;
    this.lastTransition = 0;
    this.first = true;
    this.transitions = new ArrayList();
  }
  
  //-------------------------------------------------------
  public void save(File f, ActivityDiagram nodes) 
    throws IOException
  {
   
    this.file = new FileWriter(f);
       
    saveHeader();
    saveDiagramBegin();
    
    saveStarNode();
    // Para cada nodo
    saveNodes_MainSequence(nodes);

    saveEndNode();    
    
    //saveTransitions();
    
    saveDiagramEnd() ;
    saveFileEnd();

   // saveFooter();
   
    
    this.file.close();
    
  }
  
  /** 
   * ArgoUML XMI style
   **/
  private void saveHeader() 
    throws IOException
  {
    log.debug ("Saving header.");
    this.file.write("<?xml version = '1.0' encoding = 'UTF-8' ?> \n");
    this.file.write("<XMI xmi.version = '1.2' xmlns:UML = 'org.omg.xmi.namespace.UML' timestamp = 'Mon Mar 20 21:38:11 CET 2006'> \n");
    this.file.write("<XMI.header> \n");
    this.file.write("<XMI.documentation> \n");
    this.file.write("<XMI.exporter>ArgoUML (using Netbeans XMI Writer version 1.0)</XMI.exporter> \n");
    this.file.write("<XMI.exporterVersion>0.20.x</XMI.exporterVersion> \n");
    this.file.write("</XMI.documentation> \n");
    this.file.write("<XMI.metamodel xmi.name=\"UML\" xmi.version=\"1.4\"/>  </XMI.header> \n");
    //this.file.write("<?xml version = '1.0' encoding = 'UTF-8' ?> \n");
  }
  
  /** **/
  private void saveDiagramBegin() 
    throws IOException
  {
    log.debug ("Saving DIAGRAM BEFIN.");
    this.file.write("<XMI.content> \n");
    this.file.write("<UML:Model xmi.id = '.:0000000000000821' name = 'untitledModel' isSpecification = 'false' isRoot = 'false' isLeaf = 'false' isAbstract = 'false'> \n");
    this.file.write("<UML:Namespace.ownedElement> \n");
    this.file.write("<UML:ActivityGraph xmi.id = '.:0000000000000822' isSpecification = 'false'> \n");
    this.file.write("<UML:StateMachine.context> \n");
    this.file.write("<UML:Model xmi.idref = '.:0000000000000821'/> \n");
    this.file.write("</UML:StateMachine.context> \n");
    this.file.write("<UML:StateMachine.top> \n");
    this.file.write("<UML:CompositeState xmi.id = '.:0000000000000823' name = 'top' isSpecification = 'false' isConcurrent = 'false'> \n");
    this.file.write("<UML:CompositeState.subvertex> \n");
  }

  
  /** **/
  private void saveStarNode() 
    throws IOException
  {
      log.debug ("Saving star node.");
      this.file.write("  <UML:Pseudostate xmi.id=\"UMLPseudostate.5\" name=\"Initial1\" visibility=\"public\" isSpecification=\"false\" container=\"UMLCompositeState.4\" kind=\"initial\"/> \n");
  }

  /** **/
  private void saveEndNode() 
    throws IOException
  {
      log.debug ("Saving end node.");
      this.file.write("<UML:FinalState xmi.id=\"UMLFinalState.6\" name=\"FinalState1\" visibility=\"public\" isSpecification=\"false\" container=\"UMLCompositeState.4\"/> \n");
  }
  
  /** **/
  private void saveNodes_MainSequence(ActivityDiagram nodes) 
    throws IOException
  {
    Iterator it;
    
    log.debug ("Saving main sequence.");
    
    it = nodes.iteratorActivities();
    while(it.hasNext()) {
        saveNode((Activity) it.next());
        
       /*this.actualNode = (Activity) it.next();
     
      saveNode(this.actualNode);
      this.previousNode = this.actualNode;*/
    }
  }
  
  
  private void saveNode(Activity n)
    throws IOException
  {
    log.debug ("Saving node.");
      this.file.write("<UML:ActionState xmi.id=\"" + n.getId() + "\" "); 
    this.file.write("name=\"" + n.getDescription() + "\" "); 
    this.file.write("visibility=\"public\" isSpecification=\"false\" container=\"UMLCompositeState.4\" isDynamic=\"false\" ");
/*
    this.file.write(" outgoing=\""+ this.transitionId++ +"\"");    
    if (this.first) {
      this.first = false;
    } else {
      this.file.write(" incoming=\""+ (this.transitionId-2) +"\"");
      this.transitions.add(new Transition(this.previousNode.getId(), n.getId(), (this.transitionId-1) ) );
    }
  */  
    
    this.file.write("/> \n");

  }
  
  /** **/
  private void saveDiagramEnd() 
    throws IOException
  {
    log.debug ("Saving diagram end.");
    this.file.write("</UML:CompositeState.subvertex> \n");
    this.file.write("</UML:CompositeState> \n");
    this.file.write("</UML:StateMachine.top> \n");
  }

  
  /** 
  private void saveTransitions() 
    throws IOException
  {

    Transition t;
    Iterator it;
    
    it = this.transitions.iterator();
    
    this.file.write("<UML:StateMachine.transitions> \n");
    
    while( it.hasNext() ) {
      t = (Transition) it.next();
      this.file.write(" <UML:Transition xmi.id=\""+t.getId()+"\" name=\"\" visibility=\"public\" isSpecification=\"false\" stateMachine=\"0000000000000822\" ");
      this.file.write(" source=\""+t.getSource() + "\" target=\"" + t.getTarget() +"\"/> \n");
    }
      
    this.file.write("</UML:StateMachine.transitions> \n");
    
  }**/

  /** **/
  private void saveFileEnd() 
    throws IOException
  {
    log.debug ("Saving file end.");
    this.file.write("</UML:ActivityGraph> \n");
    this.file.write("</UML:Namespace.ownedElement> \n");
    this.file.write("</UML:Model> \n");
    this.file.write("</XMI.content> \n");
    this.file.write("</XMI> \n");
  }
 
  
    //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (ActivityDiagram.class.getName());
    }

}