/*
 * XMIFileSaverStereotypeHelpper.java
 *
 * Created on 25 de mayo de 2006, 8:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel.xmi;

import java.io.*;
import java.util.Iterator;
import java.util.Set;
import objectgen.activitymodel.*;


/**
 *
 * @author Rincew
 */
public class XMIFileSaverStereotypeHelpper implements IXMIHelpper {

    private ActivityDiagram ad;
    private FileWriter file;

    /** Creates a new instance of XMIFileSaverStereotypeHelpper */
    public XMIFileSaverStereotypeHelpper () {
        this.ad = null;
        this.file = null;
    }
    
    /** Entry point **/
    public void saveElements(ActivityDiagram ad, FileWriter file) 
        throws IOException
    {
        String stereotype;
        Set sSet;
        Iterator it;
        
        this.ad = ad;
        this.file = file;
        
        sSet = this.ad.generateParticipants ();
        it = sSet.iterator ();
        
        while(it.hasNext ()) {
            stereotype = (String) it.next ();
            if (stereotype == null)
                continue;
            this.generateStereotype(stereotype);
        }
      
        
        /*
         *Despues de activityGraph
         
         *        <UML:Stereotype xmi.id="X.11" name="useCaseModel" extendedElement="UMLModel.2"/>
        <UML:Stereotype xmi.id="X.12" name="Actor" extendedElement="UMLActionState.5 UMLActionState.6 UMLActionState.7"/>

         **/
    }

    
    /*** Generates XMI for a stereotype **/
    private void generateStereotype(String s)
        throws IOException 
    {
        this.file.write ("    <UML:Stereotype xmi.id='" 
            + this.generateId(s) + "' name='" + s
            + "' extendedElement='" + this.generateListOfActivities(s) 
            + "' /> \n"
            );
    }
    
    /** Generates an Id for an stereotype */
    private String generateId(String s) {
        return "S." + s;
    }
    
    /** Generates a list with the activities id for an stereotype **/
    private String generateListOfActivities(String s) {
        Iterator it;
        Activity a;
        StringBuffer sb = new StringBuffer("");
        
        it = this.ad.iteratorActivitiesFromParticipant (s);
        while (it.hasNext ()) {
            a = (Activity) it.next ();
            sb.append (a.getId ()+" ");
        }
        
        return sb.toString ();
    }
    
}
