/*
 * XMIFileSaverTransitionHelpper.java
 *
 * Created on 19 de mayo de 2006, 23:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel.xmi;

import java.io.*;
import java.util.Iterator;

import objectgen.activitymodel.ActivityDiagram;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.Transition;
import objectgen.activitymodel.Decision;

/**
 *
 * @author Rincew
 */
public class XMIFileSaverTransitionHelpper 
    implements IXMIHelpper
{
    
    
    private ActivityDiagram ad;
    private FileWriter file;
    private static int GUARD_ID = 0;
    
    /** Creates a new instance of XMIFileSaverTransitionHelpper */
    public XMIFileSaverTransitionHelpper () {
    }

    
    
    
      /*************************************  
   * This method traverses all transitions 
   * of the activity graph 
   **/
  public void saveElements(ActivityDiagram nodes, FileWriter file) 
    throws IOException
  {
    
    this.ad = nodes;
    this.file = file;
    
    //log.debug ("Saving main sequence.");
    this.saveTransitionsBegin ();
    saveStartTransition();
    generateTransitions();
    this.saveTransitionsEnd ();
    
  }

  
        /*************************************  
   * This method traverses all transitions 
   * of the activity graph 
   **/
  private void generateTransitions() 
    throws IOException
  {
    Iterator it;
    Transition t;
    
    it = this.ad.iteratorTransitions ();
    while( it.hasNext() ) {
        t = (Transition) it.next();
        saveTransition(t);
     }
  }

  
  /******
   * This method saves a trasition
   ***/
  private void saveStartTransition() 
    throws IOException
  {
      Activity a;
      Transition t;
      
      a = this.ad.getFirstActivity ();
      if (a == null) 
          return;
      
      t = new Transition("UMLBeginNode", a.getId ());
      //saveTransition(t);
      // Error de null pointer porque no existe UMLBeginNode
          this.file.write(" <UML:Transition xmi.id = '" + 
        t.getId () + "' isSpecification = 'false'>\n"); 
    
        this.file.write("  <UML:Transition.source>\n"); 
        this.file.write("   <UML:Pseudostate xmi.idref = 'UMLBeginNode'/>\n");
        this.file.write("  </UML:Transition.source>\n"); 
        this.file.write("  <UML:Transition.target>\n"); 
        a = this.ad.findActivity (t.getDes ());
        if (a.isDesicion ())
            this.file.write("   <UML:Pseudostate xmi.idref = '"+a.getId ()+"'/>\n");
        else
            this.file.write("   <UML:ActionState xmi.idref = '"+a.getId ()+"'/>\n");
        this.file.write("  </UML:Transition.target>\n"); 

        this.file.write(" </UML:Transition>\n");

  }
      
  /******
   * This method saves a trasition
   ***/
  private void saveTransition(Transition t) 
    throws IOException
  {
      Activity a;
      Activity b;
/*
      this.file.write(" <UML:Transition xmi.id = '" + 
        t.getId () + "' isSpecification = 'false' " +
          "source='" + t.getOrg () + "' " +
          "target='" + t.getDes () + "'" + 
          ">\n"); 

  */
    this.file.write(" <UML:Transition xmi.id = '" + 
        t.getId () + "' isSpecification = 'false'>\n"); 
    
    // Nodo origen
    this.file.write("  <UML:Transition.source>\n"); 
    a = this.ad.findActivity (t.getOrg ());
    if (a.isDesicion ())
        this.file.write("   <UML:Pseudostate xmi.idref = '"+a.getId ()+"'/>\n");
    else
        this.file.write("   <UML:ActionState xmi.idref = '"+a.getId ()+"'/>\n");
    this.file.write("  </UML:Transition.source>\n"); 

    // Nodo destino
    this.file.write("  <UML:Transition.target>\n"); 
    b = this.ad.findActivity (t.getDes ());
    if (b.isDesicion ()) {
        this.file.write("   <UML:Pseudostate xmi.idref = '"+b.getId ()+"'/>\n");
    }
    else
        this.file.write("   <UML:ActionState xmi.idref = '"+b.getId ()+"'/>\n");

    this.file.write("  </UML:Transition.target>\n"); 

    if (a.isDesicion ())
        // Tengo un problema, como puedo saber si esta es la buena o no?
        saveTransitionGuard(a, t);
    
    this.file.write(" </UML:Transition>\n");
  }
  
  /**
   * Calculates and unique id for a guard
   */
  private int getGuardId() {
      return ++GUARD_ID;
  }
  
  /**
   * Saves the condition of an alternative transition
   *
   * Podria sacar a de t
   **/
  private void saveTransitionGuard(Activity a, Transition t) 
    throws IOException
  {
      Decision d = (Decision) a;
      /*
      this.file.write ("  <UML:Transition.guard> \n");
      this.file.write ("   <UML:Guard xmi.id='" + 
          this.getGuardId () + "' transition='" + 
          t.getId () + "'> \n");
      this.file.write ("   <UML:Guard.expression> \n");
      this.file.write ("    <UML:BooleanExpression xmi.id='" + 
          this.getGuardId () + "' body='" + 
          d.getConditionForNode (t.getDes ()) + "'/> \n");
      this.file.write ("   </UML:Guard.expression> \n");
      this.file.write ("  </UML:Guard> \n");
      this.file.write ("  </UML:Transition.guard> \n");
      */
      
      this.file.write ("  <UML:Transition.trigger> \n");
      this.file.write ("   <UML:SignalEvent xmi.id= '" +
          d.getConditionForNode (t.getDes ()) + "' name='" +
          d.getConditionForNode (t.getDes ()) + "' visibility='public' " +
          "isSpecification='false' transition='" +
          t.getId () + "' />\n"
          );
      this.file.write ("  </UML:Transition.trigger> \n");
  }
  
/**
 *
 *              
                <UML:Guard xmi.id="X.16" transition="UMLTransition.8">
                  
                    <UML:BooleanExpression xmi.id="X.17" body="False"/>
                  </UML:Guard.expression>
                </UML:Guard>
              </UML:Transition.guard>

 *Segn sea desicin o no, habr que generar la 
 * transicin de una manera u otra.
 *
 **/
  
  
      /** **/
 private void saveTransitionsBegin() 
    throws IOException
 {
      this.file.write(" <UML:StateMachine.transitions> \n");
 }


 /******************************
 *
 **/
    /** **/
 private void saveTransitionsEnd() 
    throws IOException
 {
      this.file.write(" </UML:StateMachine.transitions> \n");
 }


}
