package objectgen.configuration;

import java.io.FileNotFoundException;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.IOException;
import org.apache.log4j.Logger;

/**
 * This class offers a centralized point of access to property file
 */

 
public class Configuration {

      //--- Attributes -------------------------------------------------------
      protected static Properties prop = null;
      public static String FileName = "configuration.prop";
      public static String Path = System.getProperty("user.dir") + "/config";

  
	/*
	public static String GetConfigPath() {
		String s = "";
		//String fName = 	"rquery.prop";
		String workingDir = System.getProperty("user.dir");
		
		if (workingDir.endsWith("bin"))
			s +="../config/";
		else
			s +="./config/";
		
		//s += fName;
		
		return s;
	}*/

  public static void Create()
  {
    prop = new Properties();
        try {
            prop.load(new FileInputStream(Configuration.Path + "/" + 
                                          Configuration.FileName));
        } catch (Exception ex) {
            log.fatal ("Error loading configuration file: " + 
                        Configuration.FileName +
                        " from: " + Configuration.Path );
        }
  }
  
  /** **/
  public static String Get(String propName) {
    if (prop != null) {
      return (String) prop.get(propName);
    }
    log.warn("Property file not initiallized (asking for:"+propName+".");
    return "";
  }


    /** **/
    public static String Get(String propName, String defaultProp) {
        String prop = Configuration.Get(propName);
        if (prop == null) {
            log.warn("Property null in Get(String, String): " + propName);
            return defaultProp;
        }
        if ( prop.compareTo("") == 0) {
            log.info("Returning default property:"+defaultProp);
            return defaultProp;
        }
        return prop;
    } 

    
    /** Adds the path to the result **/
    public static String GetFileName(String prop) {
        String s = Configuration.Get (prop);
        return Path + "/" + s;
    }

    /** **/
    public static java.io.File GetFile(String prop) {
        java.io.File f = new java.io.File(Configuration.GetFileName (prop));
        if (f.exists () == false)
            log.fatal ("Error: file not found: " + f);
        return f;
    }
    
  /**
   * @param propName
   * @return property value as an int.
   */
  public static int GetInt(String propName) {
    String prop = Configuration.Get(propName);
    return Integer.parseInt(prop);
  }

  /**
   * @param propName
   * @return property value as an int, or default if
   * property not found.
   */
  public static int GetInt(String propName, int defaultProp) {
    String prop = Configuration.Get(propName);
    if ( prop.compareTo("") == 0)
    	return defaultProp;
    return Integer.parseInt(prop);
  }

  
  //--- Log -------------------------------------------------------
  protected static Logger log;
  static {   	log = Logger.getLogger(Configuration.class); }
  
}
