/*
 * BuildBehaviourModelCommand.java
 *
 * Created on 13 de mayo de 2006, 23:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.gui.commands;


import java.io.File;
import java.io.IOException;

import objectgen.activitymodel.*;
import objectgen.activitymodel.xmi.XMIFileSaver;
import objectgen.testobjective.*;
import objectgen.usecase.*;


/**
 *
 * @author Rincew
 */
public class BuildBehaviourModelCommand {
    
    /** Creates a new instance of BuildBehaviourModelCommand */
    public BuildBehaviourModelCommand () {
        
    }

    /** Runs the command
     */
    public String run (String file_org, String file_des) {
        
        ApplicationDataSpace ads = ApplicationDataSpace.getInstance ();
        
        File f_org = new File(file_org);
        File f_des = new File(file_des);
        
        if (f_org.exists () == false) {
            return "File '" + file_org + "' does not exist.";
        }
        /*if (f_des.exists () == true) {
            return "File '" + file_des + "' exists. Overwritting.";
        }*/

        UseCaseXML uc = new UseCaseXML();
        try {
            uc.load (f_org);
        } catch (UseCaseXMLException ex) {
            return ex.toString ();
        }
        
        ActivityDiagram ad;
        ActivityDiagramGenerator adg = new ActivityDiagramGenerator();
        ad = adg.generate (uc);
        
        XMIFileSaver xmiSaver = new XMIFileSaver();
        try {
            xmiSaver.save (f_des, ad);
        } catch (IOException ex) {
            
            ex.printStackTrace();
            return ex.toString ();
        }
    
        ads.put ("ActivityDiagram", ad);
        
        return "Ok.";
    }
}
