/*
 * TestObjective.java
 *
 * Created on 31 de mayo de 2006, 21:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import objectgen.activitymodel.ActivityDiagram;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.Decision;

import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;

import org.apache.log4j.Logger;

/**
 * A test objective is also an activity diagram
 *
 * @author Rincew
 */
public class TestObjective 
    /*extends ActivityDiagram*/
    implements Cloneable,
               java.io.Serializable
{
    
    List activities;
    
    /** Creates a new instance of TestObjective */
    public TestObjective () {
        //super();
        this.activities = new LinkedList();
    }
 
    /** Returns true if the test objective contains the 
     * indicated activity 
     */
    public boolean contains(Activity a) {
        return this.activities.contains(a);
    }
    
    
    /** Returns the first occurence of the decision d
     *in the test objective
     **/
    public Decision getFirstDecision(Decision d) {
        Activity a_aux;
        Decision aux = null;
        Iterator it = this.activities.iterator ();
        boolean b = true;
        
        while (it.hasNext ()) {
            a_aux = (Activity) it.next ();
            if (a_aux.isDesicion ()) {
                aux = (Decision) a_aux;
            
                if (aux.equals (d)) {
                    b = false;
                    break;
                }
            }
        }
        
        if (b) {
            log.warn("Warning ! No first decision found for " 
                + d + " in " + this.activities);
        }
        
        return aux;
    }
    
    
    /** Returns the last desicion stored in the objective **/
    public Decision getLastDecision() {
        Decision d_aux = null;
        Activity a_aux;
        
        int size;
        int index;
        
        size = this.activities.size ();
        
        for (index = size-1; index > 0; index-- ) {
            a_aux = (Activity) this.activities.get (index);
            if (a_aux.isDesicion ()) {
                d_aux = (Decision) a_aux;
                break;
            }
        }
        
        if (d_aux == null) 
            log.warn("No decision found in test objective: " + this.toString ());
        
        return d_aux;
        
    }
    
    
    //--- Activities from ActivityDiagram ------------------
    public void addActivity (Activity a) {
        this.activities.add(a);
    }
    

    /** Clone **/
    public Object clone() {
        TestObjective clon = new TestObjective();
        Enumeration keys;
        Object key;
        Activity tmp;
        Iterator it;
        
        it = this.activities.iterator ();
        while (it.hasNext ()) {
            clon.activities.add ( (Activity) it.next ());
        }
        
        /*
        keys = this.da.keys ();
        while (keys.hasMoreElements ()) {
            key = keys.nextElement ();
            tmp = (Activity)this.da.get (key);
            clon.da.put (key, tmp.clone());
        }
        
        clon.beginNode = (Activity)this.beginNode.clone ();
        clon.finalNode = (Activity)this.finalNode.clone ();
        */
        return clon;
    }

    /** Testing purpouse **/
    public String toString() {
        int c;
        Activity a;
        StringBuffer sb = new StringBuffer("");
        //sb.append ("TO: \n");
        
        for (c = 0; c < this.activities.size(); c++) {
            a = (Activity) this.activities.get (c);
            sb.append ( a.getId ()+ ", ");
        }
            
        //sb.append ( "\n ");
        return  sb.toString ();
    }

    
    /** **/
    public Iterator activitiesIterator() {
        return this.activities.iterator ();
    }
    
    //--- Log --------
    static Logger log;
    static {
        log = Logger.getLogger (TestObjectiveGenerator.class.getName());
    }

}
